#include <owl\applicat.h>
#include <owl\framewin.h>
#include <owl\dialog.h>
#include <owl\radiobut.h>
#include <owl\edit.h>
#include <owl\listbox.h>
#include <owl\combobox.h>
#include <owl\scrollba.h>
#include <owl\groupbox.h>
#include <owl\dc.h>
#include <string.h>
#include <cstring.h>
#include "pr57_1.rc"
 
//  .
class TApp: public TApplication
{
  public:
	 TApp():TApplication() {}
	 void InitMainWindow();
};

//   .
class TWndw : public  TFrameWindow
{
  public:
	 TWndw (TWindow *parent, const char far *title);
  protected:
         TEdit   *edit;
         TRadioButton *radio1, *radio2, *radio3;
         TListBox *listBox;
         TComboBox *comboBox;
         TCheckBox *check1, *check2, *check3;
         TScrollBar *scrollBar;

         void SetupWindow();
         void CmGetData();

         DECLARE_RESPONSE_TABLE(TWndw);
};

DEFINE_RESPONSE_TABLE1 (TWndw, TFrameWindow)
	  EV_COMMAND (CM_GETDATA, CmGetData),
END_RESPONSE_TABLE;

// TWndw::TWndw()
//    .
TWndw::TWndw(TWindow *parent, const char far *title):
			 TFrameWindow (parent, title)
{
  //      
  //  . 
  EnableKBHandler();
  //   .
  AssignMenu(MENU_1);
  //     . 
  Attr.X = 20;
  Attr.Y = 20;
  Attr.W = 600;
  Attr.H = 280;
  //     .
  new TStatic(this, -1, "Edit:", 42, 14, 50, 24, 5);
  edit = new TEdit(this, ID_EDIT, "Default", 40, 40, 100, 24, 15); 
  TGroupBox *groupBox1 = new TGroupBox(this, -1, "Check Boxes", 40, 75, 110, 125); 
  check1 = new TCheckBox(this, ID_CHECK1, "Check1", 52, 105, 68, 24, groupBox1); 
  check2 = new TCheckBox(this, ID_CHECK2, "Check2", 52, 132, 68, 24, groupBox1); 
  check3 = new TCheckBox(this, ID_CHECK3, "Check3", 52, 159, 68, 24, groupBox1); 
  TGroupBox *groupBox2 = new TGroupBox(this, -1, "Radio Buttons", 184, 14, 160, 55); 
  radio1 = new TRadioButton(this, ID_RADIO1, "R1", 190, 35, 40, 24, groupBox2); 
  radio2 = new TRadioButton(this, ID_RADIO2, "R2", 240, 35, 40, 24, groupBox2); 
  radio3 = new TRadioButton(this, ID_RADIO3, "R3", 290, 35, 40, 24, groupBox2); 
  new TStatic (this, -1, "Scroll Bar:", 375, 14, 90, 24, 11);
  scrollBar = new TScrollBar(this, ID_SCROLLER, 375, 40, 200, 22, TRUE);
  new TStatic (this, -1, "List Box:", 175, 80, 80, 24, 9); 
  listBox = new TListBox (this, ID_LISTBOX, 175, 105, 150, 75);
  new TStatic (this, -1, "Combo Box:", 350, 80, 90, 24, 10); 
  comboBox = new TComboBox(this, ID_COMBOBOX, 350, 105, 190, 100, CBS_DROPDOWNLIST, 30);
  new TButton(this, CM_GETDATA, "Get Data", 400, 150, 80, 50);
}

// TWndw::SetupWindow()
//  ,  
// SetupWindow()  , 
//     .
void TWndw::SetupWindow() 
{
  //   SetupWindow()  .
  TFrameWindow::SetupWindow();
  //     .
  radio1->Check(); 
  radio2->Uncheck(); 
  radio3->Uncheck(); 
  check1->Check(); 
  check2->Uncheck(); 
  check3->Uncheck(); 
  scrollBar->SetRange(0, 100); 
  scrollBar->SetPosition(50); 
  listBox->AddString("ListString1"); 
  listBox->AddString("ListString2"); 
  listBox->AddString("ListString3"); 
  listBox->AddString("ListString4"); 
  listBox->AddString("ListString5"); 
  listBox->AddString("ListString6"); 
  comboBox->AddString("ComboString1"); 
  comboBox->AddString("ComboString2"); 
  comboBox->AddString("ComboString3"); 
  comboBox->AddString("ComboString4"); 
  comboBox->AddString("ComboString5"); 
  comboBox->AddString("ComboString6");
  //       
  //    . 
  listBox->SetSelIndex(0); 
  comboBox->SetSelIndex(0);
}


// TWndw::CmGetData()
//      Get Data  
//  File,  ,     . 
void TWndw::CmGetData()
{
  string data; 
  char s[100]; 
  int num;

  data = "EDIT CONTROL:\t";
  edit->GetText(s, sizeof(s));
  data += s;
  data += "\r\n";
  if   (radio1->GetCheck() == BF_CHECKED) num = 1; 
  else   if   (radio2->GetCheck() == BF_CHECKED) num = 2; 
         else num =  3;
  data += "RADIO BUTTON:\t";
  wsprintf(s, "Radio button #%d chosen\r\n", num); 
  data += s;
  num = scrollBar->GetPosition(); 
  wsprintf(s, "SCROLL BAR:\t%d\r\n", num); 
  data += s;
  data += "CHECK BOX 1:\t"; 
  if (check1->GetCheck() == BF_CHECKED) data += "Chosen\r\n"; 
  else  data += "Not chosen\r\n";
  data += "CHECK BOX 2:\t"; 
  if (check2->GetCheck() == BF_CHECKED) data += "Chosen\r\n"; 
  else data += "Not chosen\r\n";
  data += "CHECK BOX 3:\t";
  if (check3->GetCheck() == BF_CHECKED) data += "Chosen\r\n"; 
  else data += "Not chosen\r\n";
  data += "LIST BOX:\t"; 
  listBox->GetSelString(s, sizeof(s)); 
  data += s;
  data += "\r\nCOMBO BOX:\t"; 
  comboBox->GetSelString(s, sizeof(s)); 
  data += s;
  MessageBox (data.c_str(), "Get Data", MB_OK);
}


void TApp::InitMainWindow()
{
  TFrameWindow *wndw = new TWndw (0,"  2");
  SetMainWindow(wndw);
}

int OwlMain(int,char *[])
{
  return TApp().Run();
}
